function diff() {
  if (!gFtp.isConnected) {
    return;
  }

  var missingRemoteFiles = new Array();
  var missingLocalFiles  = new Array();
  var differentFiles     = new Array();

  var remoteFiles        = new Array();
  for (var x = 0; x < remoteTree.data.length; ++x) {
    remoteFiles.push({ leafName: remoteTree.data[x].leafName, index: x});
  }

  for (var x = 0; x < localTree.data.length; ++x) {
    var found = false;

    for (var y = 0; y < remoteFiles.length; ++y) {
      if (localTree.data[x].leafName == remoteFiles[y].leafName) {
        found = true;
        var localFile  = localTree.data[x];
        var remoteFile = remoteTree.data[remoteFiles[y].index];
        remoteFiles.splice(y, 1);

        if (localFile.fileSize !=  remoteFile.fileSize && !localFile.isDirectory() && !remoteFile.isDirectory()) {
          differentFiles.push({ localFile: localFile, remoteFile: remoteFile, reason: gStrbundle.getString("diffFileSize"),     action: "nothing" });
          break;
        }

        if (localFile.isDirectory() != remoteFile.isDirectory()) {
          differentFiles.push({ localFile: localFile, remoteFile: remoteFile, reason: gStrbundle.getString("diffTypeMismatch"), action: "nothing" });
          break;
        }

        break;
      }
    }

    if (!found) {
      missingRemoteFiles.push({ file: localTree.data[x], action: "upload" });
    }
  }

  for (var x = 0; x < remoteFiles.length; ++x) {
    missingLocalFiles.push({ file: remoteTree.data[remoteFiles[x].index], action: "download" });
  }

  if (missingLocalFiles.length == 0 && missingRemoteFiles.length == 0 && differentFiles.length == 0) {
    doAlert(gStrbundle.getString("diffSame"));
    return;
  }

  var result = { value : false };
  window.openDialog("chrome://fireftp/content/diff.xul", "diff", "chrome,modal,dialog,resizable,centerscreen",
                    missingLocalFiles, missingRemoteFiles, differentFiles, result);

  if (result.value) {
    for (var x = 0; x < missingLocalFiles.length;  ++x) {
      if (missingLocalFiles[x].action  != "nothing") {
        var transferObj = new transfer();
        transferObj.start(missingLocalFiles[x].action  == "download", missingLocalFiles[x].file);
        if (transferObj.cancel) {
          return;
        }
      }
    }

    for (var x = 0; x < missingRemoteFiles.length; ++x) {
      if (missingRemoteFiles[x].action != "nothing") {
        var transferObj = new transfer();
        transferObj.start(missingRemoteFiles[x].action == "download", missingRemoteFiles[x].file);
        if (transferObj.cancel) {
          return;
        }
      }
    }

    for (var x = 0; x < differentFiles.length; ++x) {
      if (differentFiles[x].action != "nothing") {
        var transferObj = new transfer();
        transferObj.prompt = false;
        transferObj.start(differentFiles[x].action == "download",
                          differentFiles[x].action == "download" ? differentFiles[x].remoteFile : differentFiles[x].localFile);
        if (transferObj.cancel) {
          return;
        }
      }
    }
  }
}
